<?php

/**
 * @file
 * Piclens MediaRSS plugin
 */

/**
 * Implementation of hook_views_plugins
 */
function piclens_views_views_plugins() {
  return array(
    'row' => array(
      'media_rss' => array(
        'title' => t('MediaRSS'),
        'help' => t('Display the node with standard node view.'),
        'handler' => 'views_plugin_row_node_mediarss',
        'base' => array('node'), // only works with 'node' as base.
        'uses options' => TRUE,
        'type' => 'feed',
      ),
    ),
  );
}

/**
 * Plugin which performs a node_view on the resulting object
 * and formats it as an MediaRSS item.
 */
class views_plugin_row_node_mediarss extends views_plugin_row {
  function render($row) {
    global $base_url;

    if (empty($this->view->style_plugin->namespaces)) {
      $this->view->style_plugin->namespaces['xmlns:media'] = 'http://search.yahoo.com/mrss/';
      $this->view->style_plugin->namespaces['xmlns:atom'] = 'http://www.w3.org/2005/Atom';
    }

    // Load the specified node:
    $node = node_load($row->nid);

    $item = array();
    $item['title'] = $node->title;
    $item['link'] = url('node/'. $node->nid, array('absolute' => true));
    $item['thumbnail'] = file_create_url($node->images['thumbnail']);
    $item['content'] = file_create_url($node->images['_original']);

    return mediarssapi_format_item($item);
  }
}
